[Signum Framework](http://www.signumframework.com/)
===================================================

Signum Framework is the new Open Source framework from Signum Software for writing data-centric applications over the latest Microsoft technologies: .Net 4.0, C# 4.0, WPF, ASP.Net MVC 3.0 (Razor). 

It provides a consistent model for N-layer architectures by moving the entities to the very center of your solution using Signum.Entities. 

Our cutting-edge ORM, Signum.Engine, has one of the first full LINQ Providers implemented outside Microsoft offices.

Signum.Windows dramatically simplifies giving a WPF user interface to your entities. Also Signum.Web does the same using ASP.Net MVC 3.0 / Razor / jQuery / jQuery UI


### Main Features ###
* Entities-first approach
* ORM with a full LINQ Provider
* Unified validation
* Schema generation (and sync)
* WPF smart-client interface
* ASP.Net MVC 3.0 Razor

### Main Features ###
* Promote simple and clean code, avoiding astronautical architectures
* Favour compile-time checked C# over error-prone XML configurations
* Create a solid foundation for the integration of application modules (on schema, BL and UI code)
* Encourage a more functional way of programming
* Avoid code duplication at any cost
* Be a good citizen wherever we are (.Net, LINQ, WPF, ASP.Net MVC) following common practices and conventions

